<!--
  ~ EVS Client is part of the Gazelle Test Bed
  ~ Copyright (C) 2006-2016 IHE
  ~ mailto :eric DOT poiseau AT inria DOT fr
  ~
  ~ See the NOTICE file distributed with this work for additional information
  ~ regarding copyright ownership.  This code is licensed
  ~ to you under the Apache License, Version 2.0 (the
  ~ "License"); you may not use this file except in compliance
  ~ with the License.  You may obtain a copy of the License at
  ~
  ~   http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing,
  ~ software distributed under the License is distributed on an
  ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~ KIND, either express or implied.  See the License for the
  ~ specific language governing permissions and limitations
  ~ under the License.
  -->

<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:rich="http://richfaces.org/rich" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:param name="pageName" value="#{messages['net.ihe.gazelle.mca.ManageMessageContentAnalyzerConfiguration']}"/>
    <ui:param name="pageNameUrl" value="config/messageContentAnalyzerConfig.seam"/>
    <ui:param name="pageNameTitle" value="#{messages['net.ihe.gazelle.mca.ManageMessageContentAnalyzerConfiguration']}"/>
    <ui:define name="body">
        <s:div id="globalDiv">

            <h:form id="listForm">
                <s:token id="mcaConfTokenId" allowMultiplePosts="true"/>
                <s:div>

                    <ui:decorate template="/layout/panels/_panel_title_footer_id.xhtml">

                        <ui:param name="panel_id" value="mcaConfigList"/>
                        <ui:define name="panel_title">
                            <h:outputText value="#{messages['net.ihe.gazelle.mca.MessageContentAnalyzerConfigurations']}"/>
                            <em class="pull-right">
                                <a4j:commandLink title="#{messages['net.ihe.gazelle.mca.ResetFilters']}"
                                                 actionListener="#{configBeanGui.resetFilter()}"
                                                 render="globalDiv">
                                    <span class="gzl-icon-times-circle"/>
                                </a4j:commandLink>
                            </em>
                        </ui:define>

                        <s:decorate id="configTypeSelectionReg" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                            <ui:param name="id" value="configTypeSelection"/>
                            <ui:define name="label"><h:outputText value="#{messages['net.ihe.gazelle.mca.ConfigurationType']}"/></ui:define>
                            <h:selectOneMenu id="configTypeSelection" value="#{configBeanGui.filteredConfigType}"
                                             styleClass="form-control gzl-form-control gzl-select-text">
                                <f:selectItem itemValue="#{null}" itemLabel="#{messages['gazelle.common.button.ShowAll']}" />
                                <f:selectItems value="#{configBeanGui.getConfigTypes()}"/>
                                <a4j:ajax event="change" render="globalDiv"
                                          listener="#{configBeanGui.listConfigs()}"/>
                            </h:selectOneMenu>
                            <a4j:commandLink title="#{messages['net.ihe.gazelle.mca.ResetFilter']}"
                                             actionListener="#{configBeanGui.setFilteredConfigType(null)}"
                                             render="globalDiv">
                                <span class="gzl-icon-times"/>
                            </a4j:commandLink>
                        </s:decorate>

                        <s:decorate id="validationTypeSelectionReg" template="/layout/form/_form_field_horizontal_3-9.xhtml">
                            <ui:param name="id" value="validationTypeSelection"/>
                            <ui:define name="label"><h:outputText value="#{messages['net.ihe.gazelle.mca.ValidationType_2']}"/></ui:define>
                            <h:selectOneMenu id="validationTypeSelection" value="#{configBeanGui.selectedValidationTypeFilter}"
                                             styleClass="form-control gzl-form-control gzl-select-text">
                                <f:selectItems value="#{configBeanGui.getValidationTypeFilters()}"/>
                                <a4j:ajax event="change" render="globalDiv"
                                          listener="#{configBeanGui.listConfigs()}"/>
                            </h:selectOneMenu>
                            <a4j:commandLink event="click"
                                             actionListener="#{configBeanGui.setSelectedValidationTypeFilter(&quot;Show All&quot;)}"
                                             render="globalDiv" execute="@this">
                                <span class="gzl-icon-times"/>
                            </a4j:commandLink>
                        </s:decorate>

                        <ui:define name="panel_footer" rendered="#{s:hasRole('admin_role')}">

                            <a4j:commandButton value="#{messages['net.ihe.gazelle.mca.CreateTagConfiguration']}"
                                               actionListener="#{configBeanGui.createNewTagConfiguration()}"
                                               oncomplete="jq162('#modif_config').modal('show');"
                                               render="edition_form"
                                               rendered="#{s:hasRole('admin_role')}"
                                               styleClass="gzl-btn-green"
                                               execute="@this"/>

                            <a4j:commandButton value="#{messages['net.ihe.gazelle.mca.CreateMimeTypeConfiguration']}"
                                               actionListener="#{configBeanGui.createNewMimeTypeConfiguration()}"
                                               oncomplete="jq162('#modif_config').modal('show');"
                                               render="edition_form"
                                               rendered="#{s:hasRole('admin_role')}"
                                               styleClass="gzl-btn-green"
                                               execute="@this"/>

                            <a4j:commandButton value="#{messages['net.ihe.gazelle.mca.CreateContentAnalysisConfiguration']}"
                                               actionListener="#{configBeanGui.createNewContentAnalysisConfiguration()}"
                                               oncomplete="jq162('#modif_config').modal('show');"
                                               render="edition_form"
                                               rendered="#{s:hasRole('admin_role')}"
                                               styleClass="gzl-btn-green"
                                               execute="@this"/>

                            <h:commandLink title="#{messages['net.ihe.gazelle.mca.DownloadConfigurationAsXMLFile']}"
                                           ignoreDupResponses="true"
                                           action="#{configBeanGui.exportConfigsAsXml()}"
                                           rendered="#{s:hasRole('admin_role')}"
                                           value ="#{messages['net.ihe.gazelle.mca.ExportFilteredConfiguration']}"
                                           styleClass="gzl-btn-blue pull-right"
                                           execute="@this"/>

                        </ui:define>

                    </ui:decorate>

                    <rich:dataTable value="#{configBeanGui.configs}" var="config"
                                    rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                    render="ds" id="configTable">

                        <g:column sortBy="#{'docType'}" filterBy="#{'docType'}">
                            <ui:define name="header"><h:outputText value="#{messages['net.ihe.gazelle.mca.DocumentType']}"/></ui:define>
                            <h:outputText value="#{config.docType}"/>
                        </g:column>
                        <g:column sortBy="#{'validationType'}" filterBy="#{'validationType'}">
                            <ui:define name="header"><h:outputText value="#{messages['net.ihe.gazelle.mca.ValidationType_2']}"/></ui:define>
                            <h:outputText value="#{config.getValidationType() != null?
                                config.getValidationType().getValue() : 'N/A'}"/>
                        </g:column>

                        <g:column sortBy="#{'tag'}" filterBy="#{'tag'}"
                                  rendered="#{configBeanGui.isTagConfigFiltered()}">
                            <ui:define name="header"><h:outputText value="#{messages['net.ihe.gazelle.mca.Tag']}"/></ui:define>
                            <h:outputText value="#{config.tag}"/>
                        </g:column>

                        <g:column sortBy="#{'namespace'}" filterBy="#{'namespace'}"
                                  rendered="#{configBeanGui.isTagConfigFiltered()}">
                            <ui:define name="header"><h:outputText value="#{messages['net.ihe.gazelle.mca.Namespace']}"/></ui:define>
                            <h:outputText value="#{config.getNamespace() != null?
                                config.getNamespace():'N/A'}"/>
                        </g:column>

                        <g:column sortBy="#{'mimeType'}" filterBy="#{'mimeType'}"
                                  rendered="#{configBeanGui.isMimeTypeConfigFiltered()}">
                            <ui:define name="header"><h:outputText value="#{messages['net.ihe.gazelle.mca.MimeType']}"/></ui:define>
                            <h:outputText value="#{config.mimeType}"/>
                        </g:column>

                        <g:column sortBy="#{'startsWith'}" filterBy="#{'startsWith'}"
                                  rendered="#{configBeanGui.isContentAnalysisConfigFiltered()}">
                            <ui:define name="header"><h:outputText value="#{messages['net.ihe.gazelle.mca.StartsWith']}"/></ui:define>
                            <h:outputText value="#{config.getStartsWithAsString() != null?
                                config.getStartsWithAsString():'N/A'}"/>
                        </g:column>

                        <g:column sortBy="#{'stringPattern'}" filterBy="#{'stringPattern'}"
                                  rendered="#{configBeanGui.isContentAnalysisConfigFiltered()}">
                            <ui:define name="header"><h:outputText value="#{messages['net.ihe.gazelle.mca.StringPattern']}"/></ui:define>
                            <h:outputText value="#{config.getStringPattern() != null ?
                                config.getStringPattern():'N/A'}"/>
                        </g:column>

                        <g:column sortBy="#{'unwantedContent'}" filterBy="#{'unwantedContent'}"
                                  rendered="#{configBeanGui.isContentAnalysisConfigFiltered()}">
                            <ui:define name="header"><h:outputText value="#{messages['net.ihe.gazelle.mca.UnwantedContent']}"/></ui:define>
                            <h:outputText value="#{config.getUnwantedContent() != null ?
                                config.getUnwantedContent():'N/A'}"/>
                        </g:column>

                        <g:column sortBy="#{'configType'}" filterBy="#{'configType'}">
                            <ui:define name="header"><h:outputText value="#{messages['net.ihe.gazelle.mca.ConfigurationType']}"/></ui:define>
                            <h:outputText value="#{config.configType.name}"/>
                        </g:column>

                        <g:column>
                            <ui:define name="header">#{messages['gazelle.evs.client.Action']}</ui:define>
                            <div class="gzl-never-wrap">

                                <a4j:commandLink
                                        title="#{messages['net.ihe.gazelle.mca.ViewConfiguration']}" oncomplete="jq162('#view_config').modal('show');"
                                        actionListener="#{configBeanGui.setSelectedConfig(config)}" render="view_config_form"
                                        execute="mcaConfTokenId">
                                    <s:span styleClass="gzl-icon-search text-info"/>
                                </a4j:commandLink>

                                <a4j:commandLink
                                        title="#{messages['net.ihe.gazelle.mca.EditConfiguration']}" oncomplete="jq162('#modif_config').modal('show');"
                                        actionListener="#{configBeanGui.setSelectedConfig(config)}" render="edition_form"
                                        rendered="#{(s:hasRole('admin_role') or s:hasRole('test_editor_role')) and !config.isHardCoded()}"
                                        execute="editConfTokenId">
                                    <s:span styleClass="gzl-icon-pencil text-info"/>
                                </a4j:commandLink>

                                <a4j:commandLink
                                        title="#{messages['net.ihe.gazelle.evs.Delete']}" oncomplete="jq162('#delete_config').modal('show');"
                                        actionListener="#{configBeanGui.setSelectedConfig(config)}" render="delete_config_form"
                                        rendered="#{(s:hasRole('admin_role') or s:hasRole('test_editor_role')) and !config.isHardCoded()}"
                                        execute="mcaConfTokenId">
                                    <s:span styleClass="gzl-icon-trash-o  text-info"/>
                                </a4j:commandLink>

                                <s:span styleClass="gzl-icon-pencil" style="color:C6C6C6"
                                        rendered="#{(s:hasRole('admin_role') or s:hasRole('test_editor_role')) and config.isHardCoded()}"
                                        title="#{messages['net.ihe.gazelle.mca.ThisConfigurationCannotBeEdited']}"/>

                                <s:span styleClass="gzl-icon-trash-o" style="color:C6C6C6"
                                        rendered="#{(s:hasRole('admin_role') or s:hasRole('test_editor_role')) and config.isHardCoded()}"
                                        title="#{messages['net.ihe.gazelle.mca.ThisConfigurationCannotBeRemoved']}"/>

                            </div>
                        </g:column>
                        <f:facet name="footer">
                            <s:div style="text-align: center;">
                                <ui:include src="/util/datatableFooter.xhtml">
                                    <ui:param name="dataScrollerId" value="ds"/>
                                    <ui:param name="dataTableId" value="configTable"/>
                                </ui:include>
                            </s:div>
                        </f:facet>
                    </rich:dataTable>
                </s:div>

                <s:div id ="importDiv" rendered="#{(s:hasRole('admin_role') or s:hasRole('test_editor_role'))}">
                    <ui:decorate template="/layout/panels/_panel_title_footer_id.xhtml">

                        <ui:param name="panel_id" value="importPanel"/>
                        <ui:define name="panel_title">
                            <h:outputText value="#{messages['net.ihe.gazelle.mca.ImportConfiguration']}"/>
                        </ui:define>

                        <s:div id="uploadFile" >
                            <s:div rendered="#{configBeanGui.getUploadedFileContent() == null}">
                                <h:outputText id="fileUploadInfo"
                                              value="#{messages['net.ihe.gazelle.mca.PleaseUploadTheXMLFileContainingTheConfiguration']}"/>
                                <ul>
                                    <li>
                                        <h:outputText value="#{messages['net.ihe.gazelle.mca.IfAConfigurationDoesNotExistItWillBeAddedToTheLi']}"/>
                                    </li>
                                    <li>
                                        <h:outputText value="#{messages['net.ihe.gazelle.mca.IfAConfigurationDoesDefineTheSameDetectionElemen']}"/>
                                    </li>
                                    <li>
                                        <h:outputText value="#{messages['net.ihe.gazelle.mca.IdenticalConfigurationsWillBeIgnored']}"/>
                                    </li>
                                </ul>
                                <rich:fileUpload
                                        fileUploadListener="#{configBeanGui.uploadListener}"
                                        maxFilesQuantity="1"
                                        listHeight="60px"
                                        immediateUpload="true">
                                    <a4j:ajax event="uploadcomplete" render="uploadFile, footer"/>
                                </rich:fileUpload>
                            </s:div>

                            <s:div id="fileNameInfo" rendered="#{configBeanGui.getUploadedFileContent() != null}" styleClass="form-horizontal">

                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label"><h:outputText  value="#{messages['net.ihe.gazelle.mca.ConfigurationFile']}"/></ui:define>
                                    <h:outputText  value="#{configBeanGui.getUploadedFileName()}"  />
                                </s:decorate>

                            </s:div>

                            <s:decorate template="/layout/form/_checkbox.xhtml">
                                <ui:param name="id" value="cbClearAndImport"/>
                                <ui:define name="label">
                                    <h:outputText  value="#{messages['net.ihe.gazelle.mca.ClearAndImportConfiguration']}"/>
                                    <s:span title="#{messages['net.ihe.gazelle.mca.ByChoosingThisOptionYouWillEraseTheCurrentConfig']}"
                                            styleClass="gzl-icon-question-circle"/>
                                </ui:define>
                                <h:selectBooleanCheckbox id="cbClearAndImport" value="#{configBeanGui.clearAndImportConfigs}">
                                    <a4j:ajax event="change" render="uploadFile"/>
                                </h:selectBooleanCheckbox>
                            </s:decorate>

                            <s:div rendered="#{configBeanGui.clearAndImportConfigs}">
                                <s:span styleClass="gzl-icon-exclamation-triangle"/>
                                <h:outputText id="clearAndImportWarning"
                                              class="gzl-text-orange"
                                              value="#{messages['net.ihe.gazelle.mca.ByChoosingThisOptionImportingAConfigurationFileW']}"/>
                            </s:div>

                            <s:div id="reportDiv" rendered="configBeanGui.displayImportReport" >
                                <s:div rendered="configBeanGui.nbrDeletedConfigs != null">
                                    <h:outputText value="#{configBeanGui.nbrDeletedConfigs} #{messages['net.ihe.gazelle.mca.ConfigurationsHaveBeenRemovedFromDatabase']}"/>
                                </s:div>
                                <s:div rendered="configBeanGui.overwrittenConfigs != null">
                                    <h:outputText value="#{messages['net.ihe.gazelle.mca.FollowingConfigurationsHaveBeenOverwritten']} "/>
                                    <ul>
                                        <ui:repeat value="#{configBeanGui.overwrittenConfigs}" var="config">
                                            <li>
                                                <h:outputText value="#{config.toString()}"/>
                                            </li>
                                        </ui:repeat>
                                    </ul>
                                </s:div>
                                <s:div rendered="configBeanGui.nbrAddedConfigs != null">
                                    <h:outputText value="#{configBeanGui.noConfigMessage()})"/>
                                </s:div>

                            </s:div>
                        </s:div>


                        <ui:define name="panel_footer">
                            <s:div id="footer">
                                <a4j:commandButton styleClass="gzl-btn"
                                                   value="#{messages['net.ihe.gazelle.mca.Reset']}"
                                                   rendered="#{configBeanGui.getUploadedFileContent() != null}"
                                                   actionListener="#{configBeanGui.resetUpload()}"
                                                   render="importDiv"
                                                   execute="@this"/>
                                <a4j:commandButton value="#{messages['net.ihe.gazelle.mca.ImportConfiguration']}"
                                                   rendered="#{configBeanGui.getUploadedFileContent() != null}"
                                                   oncomplete="jq162('#import_config_report').modal('show');"
                                                   styleClass="gzl-btn-blue"
                                                   action="#{configBeanGui.importConfigsFromXml()}"
                                                   render="globalDiv, reportDiv"/>
                            </s:div>
                        </ui:define>

                    </ui:decorate>
                </s:div>
            </h:form>

            <ui:include src="_editConfigPopup.xhtml"/>
            <ui:include src="_deleteConfigPopup.xhtml"/>
            <ui:include src="_viewConfigPopup.xhtml"/>
            <ui:include src="_importConfigReportPopup.xhtml"/>
        </s:div>
    </ui:define>
</ui:composition>
